package ch.hslu.swk.g03.logger.component;

import ch.hslu.loggerinterface.LoggerSetup;
import ch.hslu.loggerinterface.Loglevel;

public class LoggiSetup implements LoggerSetup{
	
	/**
	 * The default log level
	 */
	private Loglevel logLevel = Loglevel.DEBUG;	
	
	/**
	 * The tcp/ip port of the loggi server
	 */
	private int port = 11111;
	
	/**
	 * The loggi server host name
	 */
	private String server = "localhost";
	
	/**
	 * The name of the source
	 */
	private String source = "LoggiClient";
	
	
	
	
	/**
	 * Gets the log level
	 */
	@Override
	public Loglevel getLoglevel() {
			
		return logLevel;
	}

	/**
	 * Gets the server tcp port
	 */
	@Override
	public int getPort() {

		return port;
	}

	/**
	 * Gets the server hostname
	 */
	@Override
	public String getServer() {

		return server;
	}

	/**
	 * Gets the source
	 */
	@Override
	public String getSource() {

		return source;
	}

	/**
	 * Sets the log level
	 */
	@Override
	public void setLoglevel(Loglevel arg0) {

		logLevel = arg0;		
	}

	/**
	 * Sets the tcp port
	 */
	@Override
	public void setPort(int arg0) {

		if (port > 0 && port < 65536) {
			
			port = arg0;
		} else {
			
			throw new RuntimeException();
		}
			
	}

	/**
	 * Sets the server host name
	 */
	@Override
	public void setServer(String arg0) {

		server = arg0;		
	}

	/**
	 * Sets the logmessage source
	 */
	@Override
	public void setSource(String arg0) {

		source = arg0;
	}

}
