package ch.hslu.loggerinterface;

/**
 * Possibility to configure LogLevel.
 *
 * @author SWK Interface Group 1 FS 2013
 * @version 1.0
 */
public interface LoggerSetup {
    /**
     * Sets the filter of logged messages on the server.
     * Log messages with lower severity than the defined won't be saved on the server.
     * E.g. when the log level is set to CRITICAL, messages with log level WARNING, INFO or OFF are ignored.
     * Default value is DEBUG
     *
     * @param level Sets the filter of logged messages @see ch.hslu.swk.f1301.loggerinterface.Loglevel
     */
    void setLoglevel(Loglevel level);

    /**
     * Gets the currently set filter log level.
     *
     * @return Loglevel
     */
    Loglevel getLoglevel();
    
    /**
     * sets the source string
     * 
     * @param source
     */
    void setSource(String source);
    
    /**
     * gets the source string
     *
     * @return gives the Source
     */
    String getSource();
    
    /**
     * sets the server parameters
     * 
     * @param server the server name or ip
     */
    void setServer(String server);

    /**
     * gets the server
     *
     * @return the server
     */
    String getServer();

    /**
     * sets the port
     * @param port the port
     */
    void setPort(int port);

    /**
     * gets the port
     *
     * @return the port
     */
    int getPort();
}
