/**
 * 
 */
package ch.hslu.swk.g03.logger.server;

import static org.junit.Assert.*;

import java.rmi.RemoteException;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import ch.hslu.swk.g03.logger.common.LogMessage;

/**
 * @author Felix
 *
 */
public class ServerRMITest {

    /**
     * @throws java.lang.Exception
     */
    @Before
    public void setUp() throws Exception {
    }

    /**
     * @throws java.lang.Exception
     */
    @After
    public void tearDown() throws Exception {
    }

    /**
     * Test method for {@link ch.hslu.swk.g03.logger.server.ServerRMI#ServerRMI()}.
     * @throws RemoteException 
     */
    @Test
    public void testServerRMI() throws RemoteException {
	assertNotNull(new ServerRMI());
    }

    /**
     * Test method for {@link ch.hslu.swk.g03.logger.server.ServerRMI#getAllMessages()}.
     * @throws RemoteException 
     */
    @Test
    public void testGetAllMessages() throws RemoteException {
	LoggerDB.getInstance().addMessage(new LogMessage("testGetAllMessages"));
	ServerRMI myRMI = new ServerRMI();
	assertNotNull(myRMI.getAllMessages());
    }
    
    /**
     * Compare with LoggerDB - Test method for {@link ch.hslu.swk.g03.logger.server.ServerRMI#getAllMessages()}.
     * @throws RemoteException 
     */
    @Test
    public void testGetAllMessagesCompare() throws RemoteException {
	LoggerDB.getInstance().addMessage(new LogMessage("testGetAllMessagesCompare"));
	ServerRMI myRMI = new ServerRMI();
	assertEquals(LoggerDB.getInstance().getAllMessages(), myRMI.getAllMessages());
    }    

    /**
     * Test method for {@link ch.hslu.swk.g03.logger.server.ServerRMI#getNewMessages(int)}.
     * @throws RemoteException 
     */
    @Test
    public void testGetNewMessages() throws RemoteException {
	LoggerDB.getInstance().addMessage(new LogMessage("testGetNewMessages 1"));
	LoggerDB.getInstance().addMessage(new LogMessage("testGetNewMessages 2"));
	LoggerDB.getInstance().addMessage(new LogMessage("testGetNewMessages 3"));
	ServerRMI myRMI = new ServerRMI();
	assertNotNull(myRMI.getNewMessages(1));
    }

    /**
     * Test method for {@link ch.hslu.swk.g03.logger.server.ServerRMI#getMessage(int)}.
     * @throws RemoteException 
     */
    @Test
    public void testGetMessage() throws RemoteException {
	LoggerDB.getInstance().addMessage(new LogMessage("testGetMessage"));
	ServerRMI myRMI = new ServerRMI();
	assertNotNull(myRMI.getMessage(myRMI.getMessageCount()));
    }

    /**
     * Test method for {@link ch.hslu.swk.g03.logger.server.ServerRMI#getMessageCount()}.
     * @throws RemoteException 
     */
    @Test
    public void testGetMessageCount() throws RemoteException {
	LoggerDB.getInstance().addMessage(new LogMessage("testGetMessageCount"));
	ServerRMI myRMI = new ServerRMI();
	assertEquals(LoggerDB.getInstance().getMessageCount(), myRMI.getMessageCount());
    }

}
